Index: /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.3/RefreshableHiveExperiment.cs
===================================================================
--- /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.3/RefreshableHiveExperiment.cs	(revision 6720)
+++ /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.3/RefreshableHiveExperiment.cs	(revision 6721)
@@ -225,5 +225,5 @@
     }
     #endregion
-    
+
     #region JobResultPoller Events
 
@@ -248,10 +248,10 @@
     private void RegisterResultPollingEvents() {
       jobResultPoller.ExceptionOccured += new EventHandler<EventArgs<Exception>>(jobResultPoller_ExceptionOccured);
-      jobResultPoller.JobResultsReceived += new EventHandler<EventArgs<IEnumerable<LightweightJob>>>(jobResultPoller_JobResultReceived);
+      jobResultPoller.JobResultsReceived += new EventHandler<EventArgs<IEnumerable<LightweightTask>>>(jobResultPoller_JobResultReceived);
       jobResultPoller.IsPollingChanged += new EventHandler(jobResultPoller_IsPollingChanged);
     }
     private void DeregisterResultPollingEvents() {
       jobResultPoller.ExceptionOccured -= new EventHandler<EventArgs<Exception>>(jobResultPoller_ExceptionOccured);
-      jobResultPoller.JobResultsReceived -= new EventHandler<EventArgs<IEnumerable<LightweightJob>>>(jobResultPoller_JobResultReceived);
+      jobResultPoller.JobResultsReceived -= new EventHandler<EventArgs<IEnumerable<LightweightTask>>>(jobResultPoller_JobResultReceived);
       jobResultPoller.IsPollingChanged -= new EventHandler(jobResultPoller_IsPollingChanged);
     }
@@ -262,10 +262,10 @@
       }
     }
-    private void jobResultPoller_JobResultReceived(object sender, EventArgs<IEnumerable<LightweightJob>> e) {
-      foreach (LightweightJob lightweightJob in e.Value) {
+    private void jobResultPoller_JobResultReceived(object sender, EventArgs<IEnumerable<LightweightTask>> e) {
+      foreach (LightweightTask lightweightJob in e.Value) {
         HiveJob hiveJob = GetHiveJobById(lightweightJob.Id);
         if (hiveJob != null) {
           // lastJobDataUpdate equals DateTime.MinValue right after it was uploaded. When the first results are polled, this value is updated
-          if (hiveJob.Job.State == JobState.Offline && lightweightJob.State != JobState.Finished && lightweightJob.State != JobState.Failed && lightweightJob.State != JobState.Aborted) {
+          if (hiveJob.Job.State == TaskState.Offline && lightweightJob.State != TaskState.Finished && lightweightJob.State != TaskState.Failed && lightweightJob.State != TaskState.Aborted) {
             hiveJob.Job.LastJobDataUpdate = lightweightJob.LastJobDataUpdate;
           }
@@ -289,9 +289,9 @@
                 // if the job is paused, download but don't integrate into parent optimizer (to avoid Prepare)
 
-                if (localJob.State == JobState.Paused) {
+                if (localJob.State == TaskState.Paused) {
                   localHiveJob.ItemJob = itemJob;
                 } else {
-                  if (localJob.ParentJobId.HasValue) {
-                    HiveJob parentHiveJob = GetHiveJobById(localJob.ParentJobId.Value);
+                  if (localJob.ParentTaskId.HasValue) {
+                    HiveJob parentHiveJob = GetHiveJobById(localJob.ParentTaskId.Value);
                     parentHiveJob.IntegrateChild(itemJob, localJob.Id);
                   } else {
@@ -327,13 +327,13 @@
       var jobs = this.GetAllHiveJobs();
       hiveExperiment.JobCount = jobs.Count();
-      hiveExperiment.CalculatingCount = jobs.Count(j => j.Job.State == JobState.Calculating);
-      hiveExperiment.FinishedCount = jobs.Count(j => j.Job.State == JobState.Finished);
+      hiveExperiment.CalculatingCount = jobs.Count(j => j.Job.State == TaskState.Calculating);
+      hiveExperiment.FinishedCount = jobs.Count(j => j.Job.State == TaskState.Finished);
       OnJobStatisticsChanged();
     }
 
     public bool AllJobsFinished() {
-      return this.GetAllHiveJobs().All(j => (j.Job.State == JobState.Finished
-                                                   || j.Job.State == JobState.Aborted
-                                                   || j.Job.State == JobState.Failed)
+      return this.GetAllHiveJobs().All(j => (j.Job.State == TaskState.Finished
+                                                   || j.Job.State == TaskState.Aborted
+                                                   || j.Job.State == TaskState.Failed)
                                                    && j.IsFinishedJobDownloaded);
     }
Index: /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.3/ServiceClients/HiveServiceClient.cs
===================================================================
--- /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.3/ServiceClients/HiveServiceClient.cs	(revision 6720)
+++ /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.3/ServiceClients/HiveServiceClient.cs	(revision 6721)
@@ -16,7 +16,7 @@
   [System.Runtime.Serialization.DataContractAttribute(Name = "HiveItem", Namespace = "http://schemas.datacontract.org/2004/07/HeuristicLab.Services.Hive.DataTransfer")]
   [System.SerializableAttribute()]
-  [System.Runtime.Serialization.KnownTypeAttribute(typeof(HeuristicLab.Clients.Hive.LightweightJob))]
+  [System.Runtime.Serialization.KnownTypeAttribute(typeof(HeuristicLab.Clients.Hive.LightweightTask))]
   [System.Runtime.Serialization.KnownTypeAttribute(typeof(HeuristicLab.Clients.Hive.StateLog))]
-  [System.Runtime.Serialization.KnownTypeAttribute(typeof(HeuristicLab.Clients.Hive.Job))]
+  [System.Runtime.Serialization.KnownTypeAttribute(typeof(HeuristicLab.Clients.Hive.Task))]
   [System.Runtime.Serialization.KnownTypeAttribute(typeof(HeuristicLab.Clients.Hive.Downtime))]
   [System.Runtime.Serialization.KnownTypeAttribute(typeof(HeuristicLab.Clients.Hive.HiveExperimentPermission))]
@@ -63,8 +63,8 @@
   [System.Diagnostics.DebuggerStepThroughAttribute()]
   [System.CodeDom.Compiler.GeneratedCodeAttribute("System.Runtime.Serialization", "4.0.0.0")]
-  [System.Runtime.Serialization.DataContractAttribute(Name = "LightweightJob", Namespace = "http://schemas.datacontract.org/2004/07/HeuristicLab.Services.Hive.DataTransfer")]
+  [System.Runtime.Serialization.DataContractAttribute(Name = "LightweightTask", Namespace = "http://schemas.datacontract.org/2004/07/HeuristicLab.Services.Hive.DataTransfer")]
   [System.SerializableAttribute()]
-  [System.Runtime.Serialization.KnownTypeAttribute(typeof(HeuristicLab.Clients.Hive.Job))]
-  public partial class LightweightJob : HeuristicLab.Clients.Hive.HiveItem {
+  [System.Runtime.Serialization.KnownTypeAttribute(typeof(HeuristicLab.Clients.Hive.Task))]
+  public partial class LightweightTask : HeuristicLab.Clients.Hive.HiveItem {
 
     [System.Runtime.Serialization.OptionalFieldAttribute()]
@@ -78,8 +78,8 @@
 
     [System.Runtime.Serialization.OptionalFieldAttribute()]
-    private System.Nullable<System.Guid> ParentJobIdField;
-
-    [System.Runtime.Serialization.OptionalFieldAttribute()]
-    private HeuristicLab.Clients.Hive.JobState StateField;
+    private System.Nullable<System.Guid> ParentTaskIdField;
+
+    [System.Runtime.Serialization.OptionalFieldAttribute()]
+    private HeuristicLab.Clients.Hive.TaskState StateField;
 
     [System.Runtime.Serialization.OptionalFieldAttribute()]
@@ -126,18 +126,18 @@
 
     [System.Runtime.Serialization.DataMemberAttribute()]
-    public System.Nullable<System.Guid> ParentJobId {
-      get {
-        return this.ParentJobIdField;
-      }
-      set {
-        if ((this.ParentJobIdField.Equals(value) != true)) {
-          this.ParentJobIdField = value;
-          this.RaisePropertyChanged("ParentJobId");
-        }
-      }
-    }
-
-    [System.Runtime.Serialization.DataMemberAttribute()]
-    public HeuristicLab.Clients.Hive.JobState State {
+    public System.Nullable<System.Guid> ParentTaskId {
+      get {
+        return this.ParentTaskIdField;
+      }
+      set {
+        if ((this.ParentTaskIdField.Equals(value) != true)) {
+          this.ParentTaskIdField = value;
+          this.RaisePropertyChanged("ParentTaskId");
+        }
+      }
+    }
+
+    [System.Runtime.Serialization.DataMemberAttribute()]
+    public HeuristicLab.Clients.Hive.TaskState State {
       get {
         return this.StateField;
@@ -178,11 +178,11 @@
 
     [System.Runtime.Serialization.OptionalFieldAttribute()]
-    private System.Guid JobIdField;
-
-    [System.Runtime.Serialization.OptionalFieldAttribute()]
     private System.Nullable<System.Guid> SlaveIdField;
 
     [System.Runtime.Serialization.OptionalFieldAttribute()]
-    private HeuristicLab.Clients.Hive.JobState StateField;
+    private HeuristicLab.Clients.Hive.TaskState StateField;
+
+    [System.Runtime.Serialization.OptionalFieldAttribute()]
+    private System.Guid TaskIdField;
 
     [System.Runtime.Serialization.OptionalFieldAttribute()]
@@ -216,17 +216,4 @@
 
     [System.Runtime.Serialization.DataMemberAttribute()]
-    public System.Guid JobId {
-      get {
-        return this.JobIdField;
-      }
-      set {
-        if ((this.JobIdField.Equals(value) != true)) {
-          this.JobIdField = value;
-          this.RaisePropertyChanged("JobId");
-        }
-      }
-    }
-
-    [System.Runtime.Serialization.DataMemberAttribute()]
     public System.Nullable<System.Guid> SlaveId {
       get {
@@ -242,5 +229,5 @@
 
     [System.Runtime.Serialization.DataMemberAttribute()]
-    public HeuristicLab.Clients.Hive.JobState State {
+    public HeuristicLab.Clients.Hive.TaskState State {
       get {
         return this.StateField;
@@ -255,4 +242,17 @@
 
     [System.Runtime.Serialization.DataMemberAttribute()]
+    public System.Guid TaskId {
+      get {
+        return this.TaskIdField;
+      }
+      set {
+        if ((this.TaskIdField.Equals(value) != true)) {
+          this.TaskIdField = value;
+          this.RaisePropertyChanged("TaskId");
+        }
+      }
+    }
+
+    [System.Runtime.Serialization.DataMemberAttribute()]
     public System.Nullable<System.Guid> UserId {
       get {
@@ -270,7 +270,7 @@
   [System.Diagnostics.DebuggerStepThroughAttribute()]
   [System.CodeDom.Compiler.GeneratedCodeAttribute("System.Runtime.Serialization", "4.0.0.0")]
-  [System.Runtime.Serialization.DataContractAttribute(Name = "Job", Namespace = "http://schemas.datacontract.org/2004/07/HeuristicLab.Services.Hive.DataTransfer")]
+  [System.Runtime.Serialization.DataContractAttribute(Name = "Task", Namespace = "http://schemas.datacontract.org/2004/07/HeuristicLab.Services.Hive.DataTransfer")]
   [System.SerializableAttribute()]
-  public partial class Job : HeuristicLab.Clients.Hive.LightweightJob {
+  public partial class Task : HeuristicLab.Clients.Hive.LightweightTask {
 
     [System.Runtime.Serialization.OptionalFieldAttribute()]
@@ -1144,6 +1144,6 @@
 
   [System.CodeDom.Compiler.GeneratedCodeAttribute("System.Runtime.Serialization", "4.0.0.0")]
-  [System.Runtime.Serialization.DataContractAttribute(Name = "JobState", Namespace = "http://schemas.datacontract.org/2004/07/HeuristicLab.Services.Hive.DataTransfer")]
-  public enum JobState : int {
+  [System.Runtime.Serialization.DataContractAttribute(Name = "TaskState", Namespace = "http://schemas.datacontract.org/2004/07/HeuristicLab.Services.Hive.DataTransfer")]
+  public enum TaskState : int {
 
     [System.Runtime.Serialization.EnumMemberAttribute()]
@@ -1213,7 +1213,7 @@
   [System.Diagnostics.DebuggerStepThroughAttribute()]
   [System.CodeDom.Compiler.GeneratedCodeAttribute("System.Runtime.Serialization", "4.0.0.0")]
-  [System.Runtime.Serialization.DataContractAttribute(Name = "JobData", Namespace = "http://schemas.datacontract.org/2004/07/HeuristicLab.Services.Hive.DataTransfer")]
+  [System.Runtime.Serialization.DataContractAttribute(Name = "TaskData", Namespace = "http://schemas.datacontract.org/2004/07/HeuristicLab.Services.Hive.DataTransfer")]
   [System.SerializableAttribute()]
-  public partial class JobData : object, System.Runtime.Serialization.IExtensibleDataObject, System.ComponentModel.INotifyPropertyChanged {
+  public partial class TaskData : object, System.Runtime.Serialization.IExtensibleDataObject, System.ComponentModel.INotifyPropertyChanged {
 
     [System.NonSerializedAttribute()]
@@ -1224,8 +1224,8 @@
 
     [System.Runtime.Serialization.OptionalFieldAttribute()]
-    private System.Guid JobIdField;
-
-    [System.Runtime.Serialization.OptionalFieldAttribute()]
     private System.DateTime LastUpdateField;
+
+    [System.Runtime.Serialization.OptionalFieldAttribute()]
+    private System.Guid TaskIdField;
 
     public System.Runtime.Serialization.ExtensionDataObject ExtensionData {
@@ -1252,17 +1252,4 @@
 
     [System.Runtime.Serialization.DataMemberAttribute()]
-    public System.Guid JobId {
-      get {
-        return this.JobIdField;
-      }
-      set {
-        if ((this.JobIdField.Equals(value) != true)) {
-          this.JobIdField = value;
-          this.RaisePropertyChanged("JobId");
-        }
-      }
-    }
-
-    [System.Runtime.Serialization.DataMemberAttribute()]
     public System.DateTime LastUpdate {
       get {
@@ -1273,4 +1260,17 @@
           this.LastUpdateField = value;
           this.RaisePropertyChanged("LastUpdate");
+        }
+      }
+    }
+
+    [System.Runtime.Serialization.DataMemberAttribute()]
+    public System.Guid TaskId {
+      get {
+        return this.TaskIdField;
+      }
+      set {
+        if ((this.TaskIdField.Equals(value) != true)) {
+          this.TaskIdField = value;
+          this.RaisePropertyChanged("TaskId");
         }
       }
@@ -1421,9 +1421,9 @@
 
     [System.Runtime.Serialization.OptionalFieldAttribute()]
-    private System.Guid JobIdField;
-
-    [System.Runtime.Serialization.OptionalFieldAttribute()]
     private HeuristicLab.Clients.Hive.MessageContainer.MessageType MessageField;
 
+    [System.Runtime.Serialization.OptionalFieldAttribute()]
+    private System.Guid TaskIdField;
+
     public System.Runtime.Serialization.ExtensionDataObject ExtensionData {
       get {
@@ -1432,17 +1432,4 @@
       set {
         this.extensionDataField = value;
-      }
-    }
-
-    [System.Runtime.Serialization.DataMemberAttribute()]
-    public System.Guid JobId {
-      get {
-        return this.JobIdField;
-      }
-      set {
-        if ((this.JobIdField.Equals(value) != true)) {
-          this.JobIdField = value;
-          this.RaisePropertyChanged("JobId");
-        }
       }
     }
@@ -1457,4 +1444,17 @@
           this.MessageField = value;
           this.RaisePropertyChanged("Message");
+        }
+      }
+    }
+
+    [System.Runtime.Serialization.DataMemberAttribute()]
+    public System.Guid TaskId {
+      get {
+        return this.TaskIdField;
+      }
+      set {
+        if ((this.TaskIdField.Equals(value) != true)) {
+          this.TaskIdField = value;
+          this.RaisePropertyChanged("TaskId");
         }
       }
@@ -1576,5 +1576,5 @@
 
     [System.ServiceModel.OperationContractAttribute(Action = "http://tempuri.org/IHiveService/GetJobsByResourceId", ReplyAction = "http://tempuri.org/IHiveService/GetJobsByResourceIdResponse")]
-    System.Collections.Generic.List<HeuristicLab.Clients.Hive.Job> GetJobsByResourceId(System.Guid resourceId);
+    System.Collections.Generic.List<HeuristicLab.Clients.Hive.Task> GetJobsByResourceId(System.Guid resourceId);
 
     [System.ServiceModel.OperationContractAttribute(Action = "http://tempuri.org/IHiveService/TriggerEventManager", ReplyAction = "http://tempuri.org/IHiveService/TriggerEventManagerResponse")]
@@ -1600,32 +1600,32 @@
 
     [System.ServiceModel.OperationContractAttribute(Action = "http://tempuri.org/IHiveService/AddJob", ReplyAction = "http://tempuri.org/IHiveService/AddJobResponse")]
-    System.Guid AddJob(HeuristicLab.Clients.Hive.Job job, HeuristicLab.Clients.Hive.JobData jobData, System.Collections.Generic.List<System.Guid> resourceIds);
+    System.Guid AddJob(HeuristicLab.Clients.Hive.Task job, HeuristicLab.Clients.Hive.TaskData jobData, System.Collections.Generic.List<System.Guid> resourceIds);
 
     [System.ServiceModel.OperationContractAttribute(Action = "http://tempuri.org/IHiveService/AddChildJob", ReplyAction = "http://tempuri.org/IHiveService/AddChildJobResponse")]
-    System.Guid AddChildJob(System.Guid parentJobId, HeuristicLab.Clients.Hive.Job job, HeuristicLab.Clients.Hive.JobData jobData);
+    System.Guid AddChildJob(System.Guid parentJobId, HeuristicLab.Clients.Hive.Task job, HeuristicLab.Clients.Hive.TaskData jobData);
 
     [System.ServiceModel.OperationContractAttribute(Action = "http://tempuri.org/IHiveService/GetJob", ReplyAction = "http://tempuri.org/IHiveService/GetJobResponse")]
-    HeuristicLab.Clients.Hive.Job GetJob(System.Guid jobId);
+    HeuristicLab.Clients.Hive.Task GetJob(System.Guid jobId);
 
     [System.ServiceModel.OperationContractAttribute(Action = "http://tempuri.org/IHiveService/GetJobs", ReplyAction = "http://tempuri.org/IHiveService/GetJobsResponse")]
-    System.Collections.Generic.List<HeuristicLab.Clients.Hive.Job> GetJobs();
+    System.Collections.Generic.List<HeuristicLab.Clients.Hive.Task> GetJobs();
 
     [System.ServiceModel.OperationContractAttribute(Action = "http://tempuri.org/IHiveService/GetLightweightJobs", ReplyAction = "http://tempuri.org/IHiveService/GetLightweightJobsResponse")]
-    System.Collections.Generic.List<HeuristicLab.Clients.Hive.LightweightJob> GetLightweightJobs(System.Collections.Generic.List<System.Guid> jobIds);
+    System.Collections.Generic.List<HeuristicLab.Clients.Hive.LightweightTask> GetLightweightJobs(System.Collections.Generic.List<System.Guid> jobIds);
 
     [System.ServiceModel.OperationContractAttribute(Action = "http://tempuri.org/IHiveService/GetLightweightChildJobs", ReplyAction = "http://tempuri.org/IHiveService/GetLightweightChildJobsResponse")]
-    System.Collections.Generic.List<HeuristicLab.Clients.Hive.LightweightJob> GetLightweightChildJobs(System.Nullable<System.Guid> parentJobId, bool recursive, bool includeParent);
+    System.Collections.Generic.List<HeuristicLab.Clients.Hive.LightweightTask> GetLightweightChildJobs(System.Nullable<System.Guid> parentJobId, bool recursive, bool includeParent);
 
     [System.ServiceModel.OperationContractAttribute(Action = "http://tempuri.org/IHiveService/GetLightweightExperimentJobs", ReplyAction = "http://tempuri.org/IHiveService/GetLightweightExperimentJobsResponse")]
-    System.Collections.Generic.List<HeuristicLab.Clients.Hive.LightweightJob> GetLightweightExperimentJobs(System.Guid experimentId);
+    System.Collections.Generic.List<HeuristicLab.Clients.Hive.LightweightTask> GetLightweightExperimentJobs(System.Guid experimentId);
 
     [System.ServiceModel.OperationContractAttribute(Action = "http://tempuri.org/IHiveService/GetJobData", ReplyAction = "http://tempuri.org/IHiveService/GetJobDataResponse")]
-    HeuristicLab.Clients.Hive.JobData GetJobData(System.Guid jobId);
+    HeuristicLab.Clients.Hive.TaskData GetJobData(System.Guid jobId);
 
     [System.ServiceModel.OperationContractAttribute(Action = "http://tempuri.org/IHiveService/UpdateJob", ReplyAction = "http://tempuri.org/IHiveService/UpdateJobResponse")]
-    void UpdateJob(HeuristicLab.Clients.Hive.Job jobDto);
+    void UpdateJob(HeuristicLab.Clients.Hive.Task jobDto);
 
     [System.ServiceModel.OperationContractAttribute(Action = "http://tempuri.org/IHiveService/UpdateJobData", ReplyAction = "http://tempuri.org/IHiveService/UpdateJobDataResponse")]
-    void UpdateJobData(HeuristicLab.Clients.Hive.Job jobDto, HeuristicLab.Clients.Hive.JobData jobDataDto);
+    void UpdateJobData(HeuristicLab.Clients.Hive.Task jobDto, HeuristicLab.Clients.Hive.TaskData jobDataDto);
 
     [System.ServiceModel.OperationContractAttribute(Action = "http://tempuri.org/IHiveService/DeleteJob", ReplyAction = "http://tempuri.org/IHiveService/DeleteJobResponse")]
@@ -1636,5 +1636,5 @@
 
     [System.ServiceModel.OperationContractAttribute(Action = "http://tempuri.org/IHiveService/UpdateJobState", ReplyAction = "http://tempuri.org/IHiveService/UpdateJobStateResponse")]
-    HeuristicLab.Clients.Hive.Job UpdateJobState(System.Guid jobId, HeuristicLab.Clients.Hive.JobState jobState, System.Nullable<System.Guid> slaveId, System.Nullable<System.Guid> userId, string exception);
+    HeuristicLab.Clients.Hive.Task UpdateJobState(System.Guid jobId, HeuristicLab.Clients.Hive.TaskState jobState, System.Nullable<System.Guid> slaveId, System.Nullable<System.Guid> userId, string exception);
 
     [System.ServiceModel.OperationContractAttribute(Action = "http://tempuri.org/IHiveService/StopJob", ReplyAction = "http://tempuri.org/IHiveService/StopJobResponse")]
@@ -1778,5 +1778,5 @@
     }
 
-    public System.Collections.Generic.List<HeuristicLab.Clients.Hive.Job> GetJobsByResourceId(System.Guid resourceId) {
+    public System.Collections.Generic.List<HeuristicLab.Clients.Hive.Task> GetJobsByResourceId(System.Guid resourceId) {
       return base.Channel.GetJobsByResourceId(resourceId);
     }
@@ -1810,41 +1810,41 @@
     }
 
-    public System.Guid AddJob(HeuristicLab.Clients.Hive.Job job, HeuristicLab.Clients.Hive.JobData jobData, System.Collections.Generic.List<System.Guid> resourceIds) {
+    public System.Guid AddJob(HeuristicLab.Clients.Hive.Task job, HeuristicLab.Clients.Hive.TaskData jobData, System.Collections.Generic.List<System.Guid> resourceIds) {
       return base.Channel.AddJob(job, jobData, resourceIds);
     }
 
-    public System.Guid AddChildJob(System.Guid parentJobId, HeuristicLab.Clients.Hive.Job job, HeuristicLab.Clients.Hive.JobData jobData) {
+    public System.Guid AddChildJob(System.Guid parentJobId, HeuristicLab.Clients.Hive.Task job, HeuristicLab.Clients.Hive.TaskData jobData) {
       return base.Channel.AddChildJob(parentJobId, job, jobData);
     }
 
-    public HeuristicLab.Clients.Hive.Job GetJob(System.Guid jobId) {
+    public HeuristicLab.Clients.Hive.Task GetJob(System.Guid jobId) {
       return base.Channel.GetJob(jobId);
     }
 
-    public System.Collections.Generic.List<HeuristicLab.Clients.Hive.Job> GetJobs() {
+    public System.Collections.Generic.List<HeuristicLab.Clients.Hive.Task> GetJobs() {
       return base.Channel.GetJobs();
     }
 
-    public System.Collections.Generic.List<HeuristicLab.Clients.Hive.LightweightJob> GetLightweightJobs(System.Collections.Generic.List<System.Guid> jobIds) {
+    public System.Collections.Generic.List<HeuristicLab.Clients.Hive.LightweightTask> GetLightweightJobs(System.Collections.Generic.List<System.Guid> jobIds) {
       return base.Channel.GetLightweightJobs(jobIds);
     }
 
-    public System.Collections.Generic.List<HeuristicLab.Clients.Hive.LightweightJob> GetLightweightChildJobs(System.Nullable<System.Guid> parentJobId, bool recursive, bool includeParent) {
+    public System.Collections.Generic.List<HeuristicLab.Clients.Hive.LightweightTask> GetLightweightChildJobs(System.Nullable<System.Guid> parentJobId, bool recursive, bool includeParent) {
       return base.Channel.GetLightweightChildJobs(parentJobId, recursive, includeParent);
     }
 
-    public System.Collections.Generic.List<HeuristicLab.Clients.Hive.LightweightJob> GetLightweightExperimentJobs(System.Guid experimentId) {
+    public System.Collections.Generic.List<HeuristicLab.Clients.Hive.LightweightTask> GetLightweightExperimentJobs(System.Guid experimentId) {
       return base.Channel.GetLightweightExperimentJobs(experimentId);
     }
 
-    public HeuristicLab.Clients.Hive.JobData GetJobData(System.Guid jobId) {
+    public HeuristicLab.Clients.Hive.TaskData GetJobData(System.Guid jobId) {
       return base.Channel.GetJobData(jobId);
     }
 
-    public void UpdateJob(HeuristicLab.Clients.Hive.Job jobDto) {
+    public void UpdateJob(HeuristicLab.Clients.Hive.Task jobDto) {
       base.Channel.UpdateJob(jobDto);
     }
 
-    public void UpdateJobData(HeuristicLab.Clients.Hive.Job jobDto, HeuristicLab.Clients.Hive.JobData jobDataDto) {
+    public void UpdateJobData(HeuristicLab.Clients.Hive.Task jobDto, HeuristicLab.Clients.Hive.TaskData jobDataDto) {
       base.Channel.UpdateJobData(jobDto, jobDataDto);
     }
@@ -1858,5 +1858,5 @@
     }
 
-    public HeuristicLab.Clients.Hive.Job UpdateJobState(System.Guid jobId, HeuristicLab.Clients.Hive.JobState jobState, System.Nullable<System.Guid> slaveId, System.Nullable<System.Guid> userId, string exception) {
+    public HeuristicLab.Clients.Hive.Task UpdateJobState(System.Guid jobId, HeuristicLab.Clients.Hive.TaskState jobState, System.Nullable<System.Guid> slaveId, System.Nullable<System.Guid> userId, string exception) {
       return base.Channel.UpdateJobState(jobId, jobState, slaveId, userId, exception);
     }
Index: /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.3/ServiceClients/JobData.cs
===================================================================
--- /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.3/ServiceClients/JobData.cs	(revision 6720)
+++ /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.3/ServiceClients/JobData.cs	(revision 6721)
@@ -24,8 +24,8 @@
 
 namespace HeuristicLab.Clients.Hive {
-  public partial class JobData : IDeepCloneable, IContent {
-    public JobData() { }
+  public partial class TaskData : IDeepCloneable, IContent {
+    public TaskData() { }
 
-    protected JobData(JobData original, Cloner cloner) {
+    protected TaskData(TaskData original, Cloner cloner) {
       cloner.RegisterClonedObject(original, this);
       if (original.Data != null) this.Data = new byte[original.Data.Length]; Array.Copy(original.Data, this.Data, original.Data.Length);
@@ -34,5 +34,5 @@
 
     public IDeepCloneable Clone(Cloner cloner) {
-      return new JobData(this, cloner);
+      return new TaskData(this, cloner);
     }
 
Index: /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.3/ServiceClients/LightweightTask.cs
===================================================================
--- /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.3/ServiceClients/LightweightTask.cs	(revision 6721)
+++ /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.3/ServiceClients/LightweightTask.cs	(revision 6721)
@@ -0,0 +1,60 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using HeuristicLab.Common;
+
+namespace HeuristicLab.Clients.Hive {
+  public partial class LightweightTask : IDeepCloneable, IContent {
+    public StateLog CurrentStateLog { get { return StateLog.LastOrDefault(); } }
+    public DateTime? DateCreated { get { return StateLog.Count > 0 ? new DateTime?(StateLog.First().DateTime) : null; } }
+    public DateTime? DateFinished { get { return (StateLog.Count > 0 && CurrentStateLog.State == TaskState.Finished) ? new DateTime?(CurrentStateLog.DateTime) : null; } }
+
+    public LightweightTask() {
+      StateLog = new List<StateLog>();
+    }
+
+    public LightweightTask(Task job) {
+      this.Id = job.Id;
+      this.ExecutionTime = job.ExecutionTime;
+      this.ParentTaskId = job.ParentTaskId;
+      this.StateLog = new List<StateLog>(job.StateLog);
+      this.State = job.State;
+      this.Command = job.Command;
+      this.LastJobDataUpdate = job.LastJobDataUpdate;
+    }
+
+    protected LightweightTask(LightweightTask original, Cloner cloner)
+      : base(original, cloner) {
+      this.ExecutionTime = original.ExecutionTime;
+      this.ParentTaskId = original.ParentTaskId;
+      this.StateLog = new List<StateLog>(original.StateLog);
+      this.State = original.State;
+      this.Command = original.Command;
+      this.LastJobDataUpdate = original.LastJobDataUpdate;
+    }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new LightweightTask(this, cloner);
+    }
+  }
+}
Index: /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.3/ServiceClients/MessageContainer.cs
===================================================================
--- /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.3/ServiceClients/MessageContainer.cs	(revision 6720)
+++ /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.3/ServiceClients/MessageContainer.cs	(revision 6721)
@@ -29,9 +29,9 @@
     public MessageContainer(MessageType message) {
       Message = message;
-      JobId = Guid.Empty;
+      TaskId = Guid.Empty;
     }
     public MessageContainer(MessageType message, Guid jobId) {
       Message = message;
-      JobId = jobId;
+      TaskId = jobId;
     }
 
@@ -39,5 +39,5 @@
       cloner.RegisterClonedObject(original, this);
       this.Message = original.Message;
-      this.JobId = original.JobId;
+      this.TaskId = original.TaskId;
     }
     public virtual IDeepCloneable Clone(Cloner cloner) {
Index: /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.3/ServiceClients/StateLog.cs
===================================================================
--- /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.3/ServiceClients/StateLog.cs	(revision 6720)
+++ /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.3/ServiceClients/StateLog.cs	(revision 6721)
@@ -35,5 +35,5 @@
       this.Exception = original.Exception;
       this.State = original.State;
-      this.JobId = original.JobId;
+      this.TaskId = original.TaskId;
     }
 
